%Read General Data of Network
if (k==1)
    strval='tozi-8bus.xls';
end
if (k==2)
    strval='IEEE 8 bus.xls';
end
if (k==3)
    strval='Tehran 230.xls';
end
data = xlsread(strval,1,['A4:J4']);
n_bus=data(1);
n_gen=data(2);
n_line=data(3);
n_trans=data(4);
S_base=data(5);
R_fault=data(6);
X_fault=data(7);
n_mutual=data(8);
number_backup=data(9);
number_fix=data(10);

%Read Bus Data
data = xlsread(strval,1,['A' num2str(9) ':D' num2str(9+(n_bus-1))]);
bus_number=data(:,1);
v_amplitude=data(:,2);
v_angle=data(:,3);
v_base=data(:,4);

%Calculate I_base for Each Bus
i_base=1000/sqrt(3)*S_base./v_base;

%Read Generator Data
data = xlsread(strval,1,['A' num2str(9+n_bus+3+1) ':H' num2str(9+n_bus+3+1+(n_gen-1))]);
number_of_gen=data(:,1);
gen_bus=data(:,2);
gen_r1=data(:,3);
gen_x1=data(:,4);
gen_r2=data(:,5);
gen_x2=data(:,6);
gen_r0=data(:,7);
gen_x0=data(:,8);

%Read Line Data
data = xlsread(strval,1,['A' num2str(9+n_bus+n_gen+6+2) ':I' num2str(9+n_bus+n_gen+6+2+(n_line-1))]);
number_of_line=data(:,1);
l_s_bus=data(:,2);
l_r_bus=data(:,3);
line_r1=data(:,4);
line_x1=data(:,5);
line_r2=data(:,6);
line_x2=data(:,7);
line_r0=data(:,8);
line_x0=data(:,9);
%Read Trans Data
if n_trans~=0
    data = xlsread(strval,1,['A' num2str(9+n_bus+n_gen+n_line+9+3) ':J' num2str(9+n_bus+n_gen+n_line+9+3+(n_trans-1))]);
    number_of_trans=data(:,1);
    t_s_bus=data(:,2);
    t_r_bus=data(:,3);
    trans_r1=data(:,4);
    trans_x1=data(:,5);
    trans_r2=data(:,6);
    trans_x2=data(:,7);
    trans_r0=data(:,8);
    trans_x0=data(:,9);
    trans_type=data(:,10);
end

%Read Relay Data
n_relay=2*(n_line+n_trans);
data=zeros(n_relay,27)
data1 = xlsread(strval,1,['A' num2str(9+n_bus+n_gen+n_line+n_trans+12+4) ':AA' num2str(9+n_bus+n_gen+n_line+n_trans+12+4+(n_relay-1))]);
for k=1:size(data1,1)
    data(data1(k,1),:)=data1(k,:);
end
number_of_relay=data(:,1);
relay_CT=data(:,2);
relay_IL=data(:,3);
relay_HS=data(:,4);
TSM_data=data(:,6:27);
relay_important=data(:,5);
relay_PS=120*relay_IL./relay_CT;
relay_PS=ceil(relay_PS/25)*25;
relay_RSI=(relay_PS.*relay_CT)/100;
dis_data=data(:,16:17);

%Read Mutual Data
data = xlsread(strval,1,['A' num2str(9+n_bus+n_gen+n_line+n_trans+n_relay+15+5) ':C' num2str(9+n_bus+n_gen+n_line+n_trans+n_relay+15+5+(n_mutual-1))]);
if length(data)>0
    first_line_num=data(:,1);
    second_line_num=data(:,2);
    mutual_value=data(:,3);
    line_mutual=zeros(n_line,n_line);
end
line_mutual=zeros(n_line,n_line);
for i=1:n_mutual
    line_mutual(first_line_num(i),second_line_num(i))=mutual_value(i);
    line_mutual(second_line_num(i),first_line_num(i))=mutual_value(i);
end

%Read backup relay  Data
relay_backup_elimination=xlsread(strval,1,['B' num2str(9+n_bus+n_gen+n_line+n_trans+n_relay+n_mutual+18+6) ':E' num2str(9+n_bus+n_gen+n_line+n_trans+n_relay+n_mutual+18+6+(number_backup-1))]);
Fixed_setting=xlsread(strval,1,['A' num2str(9+n_bus+n_gen+n_line+n_trans+n_relay+n_mutual+number_backup+21+7) ':H' num2str(9+n_bus+n_gen+n_line+n_trans+n_relay+n_mutual+number_backup+21+7+(number_fix-1))]);
